您的位置:首页 > 移动开发

hdu 5119 Happy Matt Friends(DP)

2018-01-28 22:47 417 查看


Happy Matt Friends

Time Limit: 6000/6000 MS (Java/Others)    Memory Limit: 510000/510000 K (Java/Others)

Total Submission(s): 4969    Accepted Submission(s): 1887


Problem Description

Matt has N friends. They are playing a game together.

Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins.

Matt wants to know the number of ways to win.

 

Input

The first line contains only one integer T , which indicates the number of test cases.

For each test case, the first line contains two integers N, M (1 ≤ N ≤ 40, 0 ≤ M ≤ 106).

In the second line, there are N integers ki (0 ≤ ki ≤ 106), indicating the i-th friend’s magic number.

 

Output

For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1) and y indicates the number of ways where Matt can win.

 

Sample Input

2
3 2
1 2 3
3 3
1 2 3

 

Sample Output

Case #1: 4
Case #2: 2

HintIn the first sample, Matt can win by selecting:
friend with number 1 and friend with number 2. The xor sum is 3.
friend with number 1 and friend with number 3. The xor sum is 2.
friend with number 2. The xor sum is 2.
friend with number 3. The xor sum is 3. Hence, the answer is 4.

 

Source

2014ACM/ICPC亚洲区北京站-重现赛(感谢北师和上交)

 

题意:

给了N个数和一个数M,问从N个数中取任意个数使得它们的异或值不小于M的方法数。

思路:

dp[i][j]中i表示前i个数中取,异或值为j的方法数。因为对于a[i]只有取和不取两种操作,所以状态转移方程容易得到是dp[i][j]=dp[i-1][j]+dp[i-1][j^a[i]]。

在对状态初始化的时候有两种写法,一种是令dp[0][0]=1;因为当没有数的时候什么都不取就是一种解法。这种解释是因为不知道a[1]的值是否为0。所以第二种写法可以是判断一下a[1]是否为0。为0时候,令dp[1][0]=2;若不为0,则令dp[1][0]=1,dp[1][a[1]]=1;

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn=1<<20;
int dp[45][maxn];
int a[45];
int main()
{
int n,m,t,cas=1;
scanf("%d",&t);
while(t--)
{
scanf("%d%d",&n,&m);
memset(dp,0,sizeof(dp));
for(int i=1;i<=n;i++)
scanf("%d",&a[i]);
dp[0][0]=1;
for(int i=1;i<=n;i++)
{
for(int j=0;j<maxn;j++)
{
dp[i][j]=dp[i-1][j]+dp[i-1][j^a[i]];
}
}
long long cnt=0;
for(int j=m;j<maxn;j++)
{
cnt+=dp
[j];
}
printf("Case #%d: %lld\n",cas++,cnt);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: